<template>
  <div class="rui-navbar-menu" :class="componentCSS">
    <button type="button" class="rui-navbar-menu__trigger">
      <rui-icon v-if="icon" :name="icon" />
      <span v-if="caption">{{ caption }}</span>
      <span>▾</span>
    </button>
    <rui-menu class="rui-navbar-menu__content">
      <slot />
    </rui-menu>
  </div>
</template>

<script>
import RuiIcon from '../Icon/Icon.vue'
import RuiMenu from '../Menu/Menu.vue'

/**
 * Menu to use in `RuiNavbar` components. It does not work well alone.
 *
 * It contains `MenuItem` components and will collapse on small screens.
 *
 * @preset Default { "slots": { "default": "<a class=\"rui-menu-item\" href=\"#\">Link #1</a>\n<a class=\"rui-menu-item\" href=\"#\">Link #2</a>"} }
 * @propsGroup Display [right, toolbar]
 * @propsGroup Content [caption, icon]
 */
export default {
  name: 'RuiNavbarMenu',
  components: { RuiMenu, RuiIcon },
  props: {
    /** Trigger caption */
    caption: { required: false, type: String, default: null },
    /** Custom trigger icon. No icon used if `null` */
    icon: { required: false, type: String, default: 'rui:more-dots' },
    /** Whether the menu is right-aligned */
    right: { required: false, type: Boolean, default: false },
    /** Whether to display menu as toolbar on large screens. Only works for buttons */
    toolbar: { required: false, type: Boolean, default: false },
  },
  computed: {
    componentCSS () {
      return [
        this.right && 'rui-navbar-menu--right',
        this.toolbar && 'rui-navbar-menu--toolbar',
      ]
    },
  },
}
</script>
